Package org.apache.lucene.analysis

# Class StopwordAnalyzerBase

java.lang.Object
org.apache.lucene.analysis.Analyzer
org.apache.lucene.analysis.StopwordAnalyzerBase

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

Direct Known Subclasses:
  `StandardAnalyzer`

public abstract class StopwordAnalyzerBase extends Analyzer
Base class for Analyzers that need to make use of stopword sets.

Since:
  3.1

## Nested Class Summary

## Nested classes/interfaces inherited from class org.apache.lucene.analysis.Analyzer

`Analyzer.ReuseStrategy, Analyzer.TokenStreamComponents`

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final CharArraySet`
`stopwords`
An immutable stopword set

### Fields inherited from class org.apache.lucene.analysis.Analyzer

`GLOBAL_REUSE_STRATEGY, PER_FIELD_REUSE_STRATEGY`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`StopwordAnalyzerBase()`
Creates a new Analyzer with an empty stopword set
`protected`
`StopwordAnalyzerBase(CharArraySet stopwords)`
Creates a new instance initialized with the given stopword set

## Method Summary

Modifier and Type
Method
Description
`CharArraySet`
`getStopwordSet()`
Returns the analyzer's stopword set or an empty set if the analyzer has no stopwords
`protected static CharArraySet`
`loadStopwordSet(Reader stopwords)`
Creates a CharArraySet from a file.
`protected static CharArraySet`
`loadStopwordSet(Path stopwords)`
Creates a CharArraySet from a path.

### Methods inherited from class org.apache.lucene.analysis.Analyzer

`attributeFactory, close, createComponents, getOffsetGap, getPositionIncrementGap, getReuseStrategy, initReader, initReaderForNormalization, normalize, normalize, tokenStream, tokenStream`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### stopwords

protected final CharArraySet stopwords
An immutable stopword set

## Constructor Details

### StopwordAnalyzerBase

protected StopwordAnalyzerBase(CharArraySet stopwords)
Creates a new instance initialized with the given stopword set

Parameters:
  `stopwords` - the analyzer's stopword set

### StopwordAnalyzerBase

protected StopwordAnalyzerBase()
Creates a new Analyzer with an empty stopword set

## Method Details

### getStopwordSet

public CharArraySet getStopwordSet()
Returns the analyzer's stopword set or an empty set if the analyzer has no stopwords

Returns:
  the analyzer's stopword set or an empty set if the analyzer has no stopwords

### loadStopwordSet

protected static CharArraySet loadStopwordSet(Path stopwords) throws IOException
Creates a CharArraySet from a path.

Parameters:
  `stopwords` - the stopwords file to load
Returns:
  a CharArraySet containing the distinct stopwords from the given file
Throws:
  `IOException` - if loading the stopwords throws an `IOException`

### loadStopwordSet

protected static CharArraySet loadStopwordSet(Reader stopwords) throws IOException
Creates a CharArraySet from a file.

Parameters:
  `stopwords` - the stopwords reader to load
Returns:
  a CharArraySet containing the distinct stopwords from the given reader
Throws:
  `IOException` - if loading the stopwords throws an `IOException`